'===== Multikeysubs definieren =====
DECLARE SUB endmulti ()
DECLARE SUB initmulti ()

'===== Intro Sub definieren
DECLARE SUB intro ()

'===== pset2 Routine definiern =====
DECLARE SUB PSET2 (x1%, y1%, c1%)

'===== Alle Variablen als Integer definieren =====
DEFINT A-Z

'===== Diese Subs sind in ASSEMBLER geschrieben und erhhen die =====
'===== Geschwindigkeit. Nhere Informationen in den ASM Dateien =====
DECLARE SUB add2 (anz%, addent%, segment%, offset%)
DECLARE SUB add (anz, ad1%, ad2%, ad3%, segmentx, offsetx, segmenty, offsety, segmentz, offsetz)

'===== Definiere das Sub fr die Initialisierung der Asm Routinen =====
DECLARE SUB init ()

'===== Definiere Variablen fr die Multi-keyroutine global =====
COMMON SHARED oldseg%, oldofs%, newseg%, newofs%, initkey$, keyflags%, newkey$, remkey$
DIM SHARED keydata%(127)

'===== Definiere Variablen / Arrays fr die Assemblerroutinen, die =====
'===== Sternenpositionen in 3d und 2d, die Farb / Tiefenarrays fr =====
'===== die derzeitige Farbe jedes Sterns und die Zahl zur Berechnung ===
'===== der Farbe des Sterns =====
DIM SHARED code2%(100), code%(100), fz%(1000), xs%(1000), ys%(1000), zs%(1000), x%(1000), y%(1000), xo%(1000), yo%(1000), f(1000), offset%, pset$, N

'===== Variablen fr den Framecounter definieren =====
DIM op AS SINGLE: DIM ppo AS SINGLE: ppo = TIMER


'===== Variable fr die Geschwindigkeit und den Focus fr die =====
'===== Projektione definieren (Variablen nicht verndern!!!!) =====
g% = 2                                       'Geschwindigkeit
dist% = 120                                  'Variable fr die Projektion

'===== ASM Routinen laden =====
init

'==== Eingangsbildschirm =====
intro

'===== Vga-Mode 13h =====
SCREEN 13

'===== Sterne & Farbe erechnen =====
FOR t = 1 TO N
xs%(t) = RND * 200 - RND * 200
ys%(t) = RND * 200 - RND * 200
zs%(s) = t - RND * 20
f(t) = RND * 13 + 17
fz%(t) = g%
NEXT

 
'===== Multikey-Interrupt aktivieren =====
initmulti
 
DO

'===== Framecounter =====
COLOR 15: LOCATE 1, 1: PRINT "fps:"
op = TIMER: ght = ght + 1: IF op > ppo + 1 THEN ppo = op: pt = ght: ght = 0
LOCATE 1, 5: PRINT pt
 


 
'===== Tastaturabfrage =====
IF keydata%(1) = 1 THEN EXIT DO
IF keydata%(75) = 1 THEN r = 1
IF keydata%(77) = 1 THEN r = -1
IF keydata%(80) = 1 THEN r2 = -1
IF keydata%(72) = 1 THEN r2 = 1

 
'===== Asm Routinen um die Sternpositionen in in X und Y Richtung =====
'===== abhngig von der Tastatureingabe verndern, Z Position jedes ===
'===== Sterns um die Geschwindigkeit erhhen =====
add N + 1, r, r2, -g%, VARSEG(xs%(0)), VARPTR(xs%(0)), VARSEG(ys%(0)), VARPTR(ys%(0)), VARSEG(zs%(0)), VARPTR(zs%(0))

'===== Tiefenzahl fr jeden Stern erhhen =====
add2 N + 1, g%, VARSEG(fz%(0)), VARPTR(fz%(0))


FOR t = 1 TO N

'===== Stern an alter Position lschen =====
PSET (xo%(t), yo%(t)), 0

'===== Z Position auf 150 setzten wenn der Stern -400 Einheiten hinter =====
'===== dem Nullpunkt liegt =====
IF zs%(t) < -400 THEN zs%(t) = 150

'===== Wenn der Stern nicht im Bildschirmbereich liegt neuen Stern
'===== berechnen =====
IF x%(t) < 0 OR x%(t) > 320 OR y%(t) < 0 OR y%(t) > 200 THEN zs%(t) = 150: ys%(t) = RND * 200 - RND * 200: xs%(t) = RND * 200 - RND * 200: f(t) = 17

'===== Farbe berechnen. Das ist nur improvisiert. Daher sollte man die =====
'===== Geschwindigkeit nicht verndern da die "Formel" auf die oben =====
'===== angegebene Geschwindigkeit geeicht ist =====
IF fz%(t) = g * 10 THEN f(t) = f(t) + 1: fz%(t) = g%

'===== Wenn der Farbwert ber 27 betrgt dann ist der Farbwert glecih 27 =====
IF f(t) > 27 THEN f(t) = 27

'===== Wenn der Focus + der Z Position gleich null ist dann Z Position -1 ===
'===== um Division durch null zu vermeiden =====
IF zs%(t) + dist% = 0 THEN zs%(t) = zs%(t) - 1

'===== Projektion =====
x%(t) = dist% * xs%(t) \ (dist% + zs%(t)) + 160
y%(t) = dist% * ys%(t) \ (dist% + zs%(t)) + 100


'===== Stern zeichen =====
PSET (x%(t), y%(t)), f(t)

'===== Position des Sterns speichern um in dann wieder zu lschen =====
xo%(t) = x%(t)
yo%(t) = y%(t)

NEXT

'===== Bewegungsvektoren lschen =====
r = 0
r2 = 0

LOOP

'===== Multikeyinterrupt lschen =====
endmulti

SUB add (anz, ad1%, ad2%, ad3%, segmentx, offsetx, segmenty, offsety, segmentz, offsetz)


DEF SEG = VARSEG(code%(0))
CALL ABSOLUTE(BYVAL anz, BYVAL ad1%, BYVAL ad2%, BYVAL ad3%, BYVAL segmentx, BYVAL offsetx, BYVAL segmenty, BYVAL offsety, BYVAL segmentz, BYVAL offsetz, VARPTR(code%(0)))
DEF SEG


END SUB

SUB add2 (anz%, addent%, segment%, offset%)
DEF SEG = VARSEG(code2%(0))
CALL ABSOLUTE(BYVAL anz%, BYVAL addent%, BYVAL segment%, BYVAL offset%, VARPTR(code2%(0)))
DEF SEG

 
END SUB

SUB endmulti

remkey$ = ""
remkey$ = remkey$ + CHR$(&H1E) ' PUSH DS
remkey$ = remkey$ + CHR$(&H55) ' PUSH BP
remkey$ = remkey$ + CHR$(&H89) + CHR$(&HE5) 'MOV BP,SP
remkey$ = remkey$ + CHR$(&H8B) + CHR$(&H56) + CHR$(&HA) ' MOV DX,[BP+0A]
remkey$ = remkey$ + CHR$(&H8E) + CHR$(&HDA) ' MOV DS,DX
remkey$ = remkey$ + CHR$(&H8B) + CHR$(&H56) + CHR$(&H8) ' MOV DX,[BP+08]
remkey$ = remkey$ + CHR$(&HB4) + CHR$(&H25) ' MOV AH,25
remkey$ = remkey$ + CHR$(&HB0) + CHR$(&H9) ' MOV AL,09
remkey$ = remkey$ + CHR$(&HCD) + CHR$(&H21) ' INT 21
remkey$ = remkey$ + CHR$(&H5D) ' POP BP
remkey$ = remkey$ + CHR$(&H1F) ' POP DS
remkey$ = remkey$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0) ' RETF 0004

offset% = SADD(remkey$)
DEF SEG = VARSEG(remkey$)
CALL ABSOLUTE(BYVAL oldseg%, BYVAL oldofs%, offset%)
DEF SEG   ' Restore the keyboard flags to their old state:
DEF SEG = 0
POKE (&H417), keyflags%
DEF SEG

END SUB

SUB init
 
  code$ = "1e5589e5b900008b46128ed88b76108b04034618890446468976108b460e8ed88b760c8b040346168904464689760c8b460a8ed88b76088b0403461489044646897608413b4e1a75be5d1fca1000"
 
  DEF SEG = VARSEG(code%(0))

  FOR I% = 0 TO 83
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code%(0)) + I%, d%
  NEXT I%
 
  DEF SEG

  code$ = "1e5589e58b460a8ed88b7608b900008b0403460c89044646413b4e0e75f15d1fca0800"

  DEF SEG = VARSEG(code2%(0))

  FOR I% = 0 TO 38
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code2%(0)) + I%, d%
  NEXT I%

  DEF SEG

pset$ = ""
pset$ = pset$ + CHR$(&H1E)                                       ' PUSH DS
pset$ = pset$ + CHR$(&H55)                                       ' PUSH BP
pset$ = pset$ + CHR$(&H89) + CHR$(&HE5)                          ' MOV BP,SP
pset$ = pset$ + CHR$(&H8B) + CHR$(&H46) + CHR$(&HA)              ' MOV AX,[BP+0A]
pset$ = pset$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HC)              ' MOV BX,[BP+0C]
pset$ = pset$ + CHR$(&H3D) + CHR$(&HC7) + CHR$(&H0)              ' CMP AX,00C7
pset$ = pset$ + CHR$(&H7F) + CHR$(&H2C)                          ' JG Ende
pset$ = pset$ + CHR$(&H3D) + CHR$(&H0) + CHR$(&H0)               ' CMP AX,0000
pset$ = pset$ + CHR$(&H7C) + CHR$(&H27)                          ' JL Ende
pset$ = pset$ + CHR$(&H81) + CHR$(&HFB) + CHR$(&H3F) + CHR$(&H1) ' CMP BX,013F
pset$ = pset$ + CHR$(&H7F) + CHR$(&H21)                          ' JG Ende
pset$ = pset$ + CHR$(&H83) + CHR$(&HFB) + CHR$(&H0)              ' CMP BX,+00
pset$ = pset$ + CHR$(&H7C) + CHR$(&H1C)                          ' JL Ende
pset$ = pset$ + CHR$(&H89) + CHR$(&HC2)                          ' MOV DX,AX
pset$ = pset$ + CHR$(&HB1) + CHR$(&H6)                           ' MOV CL,06
pset$ = pset$ + CHR$(&HD3) + CHR$(&HE2)                          ' SHL DX,CL
pset$ = pset$ + CHR$(&HFE) + CHR$(&HC1)                          ' INC CL
pset$ = pset$ + CHR$(&HFE) + CHR$(&HC1)                          ' INC CL
pset$ = pset$ + CHR$(&HD3) + CHR$(&HE0)                          ' SHL AX,CL
pset$ = pset$ + CHR$(&H1) + CHR$(&HD0)                           ' ADD AX,DX
pset$ = pset$ + CHR$(&H1) + CHR$(&HD8)                           ' ADD AX,BX
pset$ = pset$ + CHR$(&H89) + CHR$(&HC6)                          ' MOV SI,AX
pset$ = pset$ + CHR$(&H8A) + CHR$(&H4E) + CHR$(&H8)              ' MOV CL,[BP+08]
pset$ = pset$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&HA0)              ' MOV AX,A000
pset$ = pset$ + CHR$(&H8E) + CHR$(&HD8)                          ' MOV DS,AX
pset$ = pset$ + CHR$(&H88) + CHR$(&HC)                           ' MOV [SI],CL
pset$ = pset$ + CHR$(&H5D)                                       ' Ende: POP BP
pset$ = pset$ + CHR$(&H1F)                                       ' POP DS
pset$ = pset$ + CHR$(&HCA) + CHR$(&H6) + CHR$(&H0)               ' RETF 0006

 
END SUB

SUB initmulti

newkey$ = ""
newkey$ = newkey$ + CHR$(&H1E) ' PUSH DS
newkey$ = newkey$ + CHR$(&H50) ' PUSH AX
newkey$ = newkey$ + CHR$(&H53) ' PUSH BX
newkey$ = newkey$ + CHR$(&HBB) + MKI$(VARSEG(keydata%(0))) ' MOV BX, SEG keydata%(0)
newkey$ = newkey$ + CHR$(&H8E) + CHR$(&HDB) ' MOV DS,BX
newkey$ = newkey$ + CHR$(&HE4) + CHR$(&H60) ' IN AL,60
newkey$ = newkey$ + CHR$(&H30) + CHR$(&HE4) ' XOR AH,AH
newkey$ = newkey$ + CHR$(&H3C) + CHR$(&H7F) ' CMP AL,7F
newkey$ = newkey$ + CHR$(&H77) + CHR$(&HA) ' JA Release
newkey$ = newkey$ + CHR$(&HD0) + CHR$(&HE0) ' SHL AL,1
newkey$ = newkey$ + CHR$(&H89) + CHR$(&HC3) ' MOV BX,AX
newkey$ = newkey$ + CHR$(&HB0) + CHR$(&H1) ' MOV AL,01
newkey$ = newkey$ + CHR$(&H88) + CHR$(&H7) ' MOV [BX],AL
newkey$ = newkey$ + CHR$(&HEB) + CHR$(&HA) ' JMP Endkey
newkey$ = newkey$ + CHR$(&H24) + CHR$(&H7F) ' Release: AND AL,7F
newkey$ = newkey$ + CHR$(&HD0) + CHR$(&HE0) ' SHL AL,1
newkey$ = newkey$ + CHR$(&H89) + CHR$(&HC3) ' MOV BX,AX
newkey$ = newkey$ + CHR$(&HB0) + CHR$(&H0) ' MOV AL,00
newkey$ = newkey$ + CHR$(&H88) + CHR$(&H7) ' MOV [BX],AL
newkey$ = newkey$ + CHR$(&HE4) + CHR$(&H61) 'Endkey: IN AL,61
newkey$ = newkey$ + CHR$(&HC) + CHR$(&H80) ' OR AL,80
newkey$ = newkey$ + CHR$(&HE6) + CHR$(&H61) ' OUT 61,AL
newkey$ = newkey$ + CHR$(&HB0) + CHR$(&H20) ' MOV AL,20
newkey$ = newkey$ + CHR$(&HE6) + CHR$(&H20) ' OUT 20,AL
newkey$ = newkey$ + CHR$(&H5B) ' POP BX
newkey$ = newkey$ + CHR$(&H58) ' POP AX
newkey$ = newkey$ + CHR$(&H1F) ' POP DS
newkey$ = newkey$ + CHR$(&HCF) ' IRET   '

newseg% = VARSEG(newkey$) ' Segment address of our keyboard handler
newofs% = SADD(newkey$) ' Offset address of our keyboard handler
initkey$ = ""
initkey$ = initkey$ + CHR$(&H1E) ' PUSH DS
initkey$ = initkey$ + CHR$(&H55) ' PUSH BP
initkey$ = initkey$ + CHR$(&H89) + CHR$(&HE5) 'MOV BP,SP
initkey$ = initkey$ + CHR$(&HB4) + CHR$(&H35) 'MOV AH,35
initkey$ = initkey$ + CHR$(&HB0) + CHR$(&H9) ' MOV AL,09
initkey$ = initkey$ + CHR$(&HCD) + CHR$(&H21) ' INT 21
initkey$ = initkey$ + CHR$(&H89) + CHR$(&HDF) ' MOV DI,BX
initkey$ = initkey$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HE) ' MOV BX,[BP+0E]
initkey$ = initkey$ + CHR$(&H8C) + CHR$(&H7) ' MOV [BX],ES
initkey$ = initkey$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HC) 'MOV BX,[BP+0C]
initkey$ = initkey$ + CHR$(&H89) + CHR$(&H3F) ' MOV [BX],DI
initkey$ = initkey$ + CHR$(&H8B) + CHR$(&H56) + CHR$(&HA) ' MOV DX,[BP+0A]
initkey$ = initkey$ + CHR$(&H8E) + CHR$(&HDA) ' MOV DS,DX
initkey$ = initkey$ + CHR$(&H8B) + CHR$(&H56) + CHR$(&H8) ' MOV DX,[BP+08]
initkey$ = initkey$ + CHR$(&HB4) + CHR$(&H25) ' MOV AH,25
initkey$ = initkey$ + CHR$(&HB0) + CHR$(&H9) ' MOV AL,09
initkey$ = initkey$ + CHR$(&HCD) + CHR$(&H21) ' INT 21
initkey$ = initkey$ + CHR$(&H5D) ' POP BP
initkey$ = initkey$ + CHR$(&H1F) ' POP DS
initkey$ = initkey$ + CHR$(&HCA) + CHR$(&H8) + CHR$(&H0) ' RETF 0008

DEF SEG = 0
keyflags% = PEEK(&H417) AND &H70
DEF SEG   ' Install our new keyboard handler:

offset% = SADD(initkey$)
DEF SEG = VARSEG(initkey$)
CALL ABSOLUTE(oldseg%, oldofs%, BYVAL newseg%, BYVAL newofs%, offset%)
DEF SEG

END SUB

SUB intro

CLS
COLOR 1
FOR t = 1 TO 80
LOCATE 1, t
PRINT ""
NEXT t
COLOR 15, 1
LOCATE 1, 33
PRINT "STARFIELD"; : COLOR 7: PRINT " V1.01"
PRINT
COLOR 15, 0
LOCATE , 40 - 15 \ 2
PRINT "Tastenbelegung:"
PRINT
LOCATE , 20
PRINT "DOWN ARROW :";
COLOR 7
PRINT " - Bewegung nach unten"
LOCATE , 20
COLOR 15
PRINT "UP ARROW :";
COLOR 7
PRINT " - Bewegung; nach; oben; "; ""
LOCATE , 20
COLOR 15
PRINT "RIGHT ARROW :";
COLOR 7
PRINT " - Bewegung nach rechts"
LOCATE , 20
COLOR 15
PRINT "LEFT ARROW :";
COLOR 7
PRINT " - Bewegung nach links"
COLOR 14
LOCATE , 20
COLOR 15
PRINT "ESC :";
COLOR 7
PRINT " - Ende"
COLOR 4

PRINT
PRINT "STARFIELD VERSION 1.02:"
COLOR 8
LOCATE , 30
PRINT "- "; : COLOR 15: PRINT " Geschrieben von Mario Zechner"
LOCATE , 30
COLOR 8
PRINT "- "; : COLOR 15: PRINT " Multikey-Interrupt von Petter Holmberg "
LOCATE , 30
COLOR 8
PRINT "- "; : COLOR 14: PRINT " ASM Routinen-Einsatz"; : COLOR 15: PRINT " fr mehr Geschwindigkeit "
LOCATE , 30
COLOR 8
PRINT "- "; : COLOR 15: PRINT " Geschwindigkeit im Vergleich zur"
LOCATE , 33
PRINT "Version 1.02 um"; : COLOR 20, 0: PRINT " 4%"; : COLOR 15: PRINT " gesteigert "
LOCATE , 30
COLOR 8
PRINT "- "; : COLOR 15: PRINT " Es gibt jedoch Probleme mit dem "
LOCATE , 30
COLOR 8
PRINT "  "; : COLOR 15: PRINT " Multikey-Interrupt beim kompilieren"
LOCATE , 30
COLOR 8
PRINT "- "; : COLOR 15: PRINT " Bis zu "; : COLOR 14: PRINT "1000 "; : COLOR 15: PRINT "Sterne gleichzeitig"
LOCATE 10, 1
c = 7
FOR t = 1 TO 80
IF c = 9 THEN c = 7
COLOR c
PRINT "-";
c = c + 1
NEXT

LOCATE 20, 1
c = 7
FOR t = 1 TO 80
IF c = 9 THEN c = 7
COLOR c
PRINT "-";
c = c + 1
NEXT

LOCATE 11, 27
FOR t = 0 TO 8
IF c = 9 THEN c = 7
LOCATE 11 + t, 27
COLOR c
PRINT "";
c = c + 1
NEXT


LOCATE 14, 1
COLOR 2
PRINT " Mailt Vorschlge , Lob,"
PRINT " Kritik, Fragen etc. an:"
PRINT
PRINT " Marzec.5b@bgrein.at.ac"
LOCATE 21, 10
COLOR 12
LOCATE , 24: PRINT "Anzahl der Sterne:";
COLOR 7
INPUT "", N
PRINT
PRINT
LOCATE , 30
COLOR 8
PRINT "-";
COLOR 7
PRINT "-";
COLOR 20
PRINT " PRESS A KEY ";
COLOR 7
PRINT "-";
COLOR 8
PRINT "-";
a$ = INPUT$(1)

END SUB

SUB PSET2 (x1%, y1%, c1%)
DEF SEG = VARSEG(pset$)
CALL ABSOLUTE(BYVAL x1%, BYVAL y1%, BYVAL c1%, offset%)
DEF SEG

END SUB

